<?php
require_once('lassospkit_datadir.inc.php');
require_once('lassospkit_debug.inc.php');

$LassoSPKitSessionFile_key = "__LassoSPKitSessionObject";

class LassoSPKitSessionPHP {
    function retrieve($session, $timeout) {
        global $LassoSPKitSessionPHP_key;

        $content = null;
        if (! isset($_SESSION)) {
            throw new Exception("LassoSPKit cannot work without PHP sessions if use_session is TRUE.");
        }
        if (isset($_SESSION[$LassoSPKitSessionFile_key])) {
            $content = $_SESSION[$LassoSPKitSessionFile_key];
            if (! isset($_SESSION[$LassoSPKitSessionFile_key . '_time']) ||
                $_SESSION[$LassoSPKitSessionFile_key . '_time'] - time() > $timeout) {
                    $content = null;
                    self::delete($session);
                }
        }
        return $content;
    }
    function store($session, $content) {
        global $LassoSPKitSessionPHP_key;
        $_SESSION[$LassoSPKitSessionFile_key] = $content;     
        $_SESSION[$LassoSPKitSessionFile_key . '_time'] = time();     
    }
    function delete($session) {
        unset($_SESSION[$LassoSPKitSessionFile_key]);     
        unset($_SESSION[$LassoSPKitSessionFile_key . '_time']);
    }
}
